'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var tippy = _interopDefault(require('tippy.js'));
var assign = _interopDefault(require('nano-assign'));

// eslint-disable-next-line no-unused-vars
var hasBindingChanged = function (value, oldValue) {
  return Object.keys(value).some(function (key) {
    return value[key] !== oldValue[key]
  })
};

var tippy$1 = function (opts) {
  if ( opts === void 0 ) opts = {};

  var init = function (el, ref) {
    var value = ref.value; if ( value === void 0 ) value = {};
    var oldValue = ref.oldValue; if ( oldValue === void 0 ) oldValue = {};

    if (el._tippy) {
      if (hasBindingChanged(value, oldValue)) {
        // Re-initialize the element when binding value changes
        // TODO: find a way to update settings w/o recreate the tippy instance
        el._tippy.destroy();
        tippy(el, assign({}, opts,
          value,
          {dynamicTitle: true}));
      }
    } else {
      tippy(el, assign({}, opts,
        value,
        {dynamicTitle: true}));
    }
  };

  var unbind = function (el) {
    if (el._tippy) {
      el._tippy.destroy();
    }
  };

  return {
    inserted: init,
    componentUpdated: init,
    unbind: unbind
  }
};

var index = function (Vue, opts) {
  Vue.directive('tippy', tippy$1(opts));
};

module.exports = index;
